/**
 * leonio.h 
 * 
 * Created on:  2013
 *     Author: Matthias
 * 
 */

#include <stdint.h>

#ifndef _LEONIO_H_
#define _LEONIO_H_


#define TRUE 1
#define FALSE 0



/*gpio0*/
#define GPIO0_BASE_ADDR ((uint32_t *) 0x80000900)
/*gpio1*/
#define GPIO1_BASE_ADDR ((uint32_t *) 0x80000A00)

#define GPIO0_DATA_OFFSET (0x0)
#define GPIO0_OUTPUT_OFFSET (0x4)
#define GPIO0_DIR_OFFSET (0x8)
typedef struct {
  uint32_t data;
  uint32_t output;
  uint32_t dir;
} GPIO_t;

/*LEGACY*/
#define GPIO0_BASE_REG (*(uint32_t *)GPIO0_BASE_ADDR)

#define GPIO0_DATA_REG (*(uint32_t *)(GPIO0_BASE_ADDR+GPIO0_DATA_OFFSET))
#define GPIO0_OUTPUT_REG (*(uint32_t *)(GPIO0_BASE_ADDR+GPIO0_OUTPUT_OFFSET))
#define GPIO0_DIR_REG (*(uint32_t *)(GPIO0_BASE_ADDR+GPIO0_DIR_OFFSET))

/*timer0*/

#define TIMER_IRQ0 (8)

#define TIMER0_BASE_ADDR ((uint32_t *) 0x80000300)

typedef struct {
  uint32_t presc_val;
  uint32_t presc_rel;
  uint32_t config;
  uint32_t unused;
  uint32_t tmr1cnt;
  uint32_t tmr1rel;
  uint32_t tmr1ctrl;
  uint32_t unused2;
  uint32_t tmr2cnt;
  uint32_t tmr2rel;
  uint32_t tmr2ctrl;
} TIMER_t;

#define TIMER0_BASE_REG (* (uint32_t *) TIMER0_BASE_ADDR)



#endif /*_LEONIO_H*/
