#include <leonio.h>

/*apb uart*/
#define UART_BASE_ADDR ((uint32_t *) 0x80000100)

typedef struct {
  uint32_t dr;
  uint32_t sr;
  uint32_t cr;
  uint32_t scaler;
  uint32_t fifo_dbg;
} UART_t;


void uart_init(UART_t *dev);

void uart_send_byte(UART_t *dev, uint8_t byte);

uint8_t uart_recv_byte(UART_t *dev);

uint8_t uart_try_recv_byte(UART_t *dev, uint8_t *byte);