/*LEGACY system test code - here for historic purpose only*/
#include <leonio.h>
#include <irq.h>
#include <stdint.h>



volatile GPIO_t *gpio0_dev = (GPIO_t *)GPIO0_BASE_ADDR;
volatile TIMER_t *timer0_dev = (TIMER_t *)TIMER0_BASE_ADDR;


void timer_isr(uint32_t id) {
  timer0_dev->tmr1ctrl |= (1<<4);
}


int main(void) {
  uint32_t cpuid;
  
  cpuid = get_cpuid();
  

  if(cpuid == 0) {
    int i,w1,w2; 
    
    init_irqmp();
    register_isr(TIMER_IRQ0,timer_isr);
    activate_interrupt(1, TIMER_IRQ0);
    
    /*general function test*/
    gpio0_dev->dir |= 0x1;

    for(i = 0; i < 3;i++) {
      gpio0_dev->output |= 0x01;
      for(w1 = 0; w1 < 3; w1++);
	  
      gpio0_dev->output &= ~0x01;
      for(w2 = 0; w2 < 3; w2++);  
    }
	
    gpio0_dev->dir &= ~0x1;
    /*end gpio test*/
    start_2nd_cpu();
    for(;;);
    
  } else if(cpuid == 1) {

    gpio0_dev->dir |= 0xff;
    /*test timer0*/
    timer0_dev->presc_val = 100;
    timer0_dev->presc_rel = 100;
	
	
    timer0_dev->tmr1rel = 50;
    timer0_dev->tmr1ctrl |= (1<<2);/*load reload value in timer counter register*/
    timer0_dev->tmr1ctrl = (1<<3) | (3<<0);/*set restart bit (automatic reload upon underflow) and start the timer*/
	
    while(timer0_dev->tmr1cnt) {
      gpio0_dev->output = timer0_dev->tmr1cnt;
    }

    /*stop timer again*/
    /*timer0_dev->tmr1ctrl = 0;*/
    gpio0_dev->output = 0;	
	
    for(;;);
  }

  return 0;
}
