/**
 * led.h 
 * 
 * Created on: Oct. 24, 2013
 *     Author: Christian
 * Added LED_MASK_09, changed LEDR_OFFSET, Matthias
 */

#include <leonio.h>

#ifndef _LED_H_
#define _LED_H_

/*****************************************************************************
 * S Y M B O L I C   C O N S T A N T S                                       *
 *****************************************************************************/

#define LED_MASK_10 (0x000003FFu)
#define LED_MASK_09 (0x000001FFu)
#define LED_MASK_08 (0x000000FFu)
#define LED_MASK_20 (0x000FFFFFu)

#define LED_MASK_L5 (0x0000001Fu)
#define LED_MASK_U5 (0x000003E0u)

#define LEDG_OFFSET  0x00u
/*#define LEDR_OFFSET  0x0Au*/
#define LEDR_OFFSET  0x00u

#define GREEN_LEDS   0x01u
#define RED_LEDS     0x02u

#define FLASH_DURATION_OUTER 10 /*10 */
#define FLASH_DURATION_INNER 200 /*200 */

/*****************************************************************************
 * F U N C T I O N   P R O T O T Y P E S                                     *
 *****************************************************************************/

void display_seconds(unsigned char seconds);
void flash_leds(unsigned char led_color);

#endif
