/**
 * uart.c.c
 *
 * Created on: March,  2014
 *     Author:  Matthias
 *
 */
#include <uart.h>


void uart_init(UART_t *dev) {

	/*reset this register (needed for simulation)*/
	dev->cr = 0;
	dev->scaler = 54; /*baudrate 115200@50 Mhz*/
	dev->cr |= (3<<0) | (1<<6); /* receiver and transmitter, enable data flow*/


}



void uart_send_byte(UART_t *dev, uint8_t byte) {

	while(!(dev->sr & 2));

	dev->dr = byte;

}


uint8_t uart_recv_byte(UART_t *dev) {

	while(!(dev->sr & 1));

	return dev->dr;
}


